#!/bin/bash
#Copyright 2008-2011 (c) syslint.com
RED='\033[01;31m'
GREEN='\033[01;32m'
RESET='\033[0m'
clear
echo -e "$GREEN*************************************************************$RESET"
echo -e "          cPnginx Installation Wizard"
echo -e "          Copyright (c)  http://syslint.com/"
echo -e "$GREEN*************************************************************$RESET"
echo " "
echo " "

echo -ne "Checking for cPanel .."
if [ -e  "/usr/local/cpanel/version" ]; then
	echo -e "[ $GREEN YES $RESET ]"
else
	echo -e "[ $RED No $RESET ]"
	exit
fi

echo -ne "Checking for previous installation .."

if [ -e  "/etc/cpnginx/data.conf" ]; then
	echo ""
	echo -e "$RED********************************************************$RESET"
	echo -e	"This is a major upgrade .So you may please run the following "
	echo -e	"command for upgrading."
	echo -e "sh majorupdate.sh"
	echo -e "$RED********************************************************$RESET"
	exit
fi
if [ -e  "/etc/cpnginx/cpnginx.conf" ]; then
	echo -e "[ $GREEN FOUND $RESET ]"
	rm -fr /etc/cpnginx/version.txt
	rm -fr /etc/cpnginx/data.conf
	rm -rf /etc/cpnginx/uninstall.sh
	rm -rf /scripts/cpnginx
	rm -rf /scripts/installmodrpaf
	rm -rf /scripts/installnginx
	rm -rf /scripts/monitornginxvhost
	rm -rf /scripts/posteasyapache
	rm -rf /scripts/postupdateuserdomains
	rm -rf /scripts/rebuildnginxvhost
	rm -fr /etc/cron.weekly/updatecpnginx.sh
	rm -rf /usr/local/cpanel/whostmgr/docroot/cgi/cpnginx
	rm -f /etc/cpnginx/cpanelproxy.conf
	mkdir  /etc/cpnginx/direct  > /dev/null
	mkdir  /etc/cpnginx/expires  > /dev/null
	mkdir  /etc/cpnginx/custom  > /dev/null
	chown -R root.root etc/
	chown -R root.root scripts/
	chown -R root.root cgi/
	chmod 700 scripts/* -R
	 /bin/chgrp nobody /home*/*/public_html     #fix group permission issue in all public_html folders
	cp -f etc/cpnginx/version.txt /etc/cpnginx/
	cp -f etc/cpnginx/uninstall.sh /etc/cpnginx/
	cp -rf scripts/* /scripts/
	cp -rf cgi/* /usr/local/cpanel/whostmgr/docroot/cgi/
	if [ -e "/usr/local/cpanel/bin/register_appconfig" ]; then
    		if [ ! -d "/var/cpanel/apps" ]; then
        		mkdir /var/cpanel/apps
        	chmod 755 /var/cpanel/apps
		fi
    		/usr/local/cpanel/bin/register_appconfig /usr/local/cpanel/whostmgr/docroot/cgi/cpnginx/cpnginx.conf
    		/bin/rm -f /usr/local/cpanel/whostmgr/docroot/cgi/addon_cpnginx.cgi
	else
    		chmod -v 700 /usr/local/cpanel/whostmgr/docroot/cgi/addon_cpnginx.cgi
		if [ -e "/usr/local/cpanel/3rdparty/bin/perl" ]; then
			sed -i 's/#\!\/usr\/bin\/perl/#\!\/usr\/local\/cpanel\/3rdparty\/bin\/perl/g' /usr/local/cpanel/whostmgr/docroot/cgi/addon_cpnginx.cgi
		fi
	fi
	cp -f updatecpnginx.sh /etc/cron.weekly/
	chmod 750 /etc/cron.weekly/updatecpnginx.sh
	
	echo -ne "Checking for cPanel proxy .."
	if  grep  "cpanelproxy.conf" /usr/local/nginx/conf/nginx.conf ; then
		cp -f etc/cpnginx/cpanelproxy.conf /etc/cpnginx/
		echo -e "[ $GREEN FOUND $RESET ]"
	else
		echo -e "[ $RED No $RESET ]"
		echo  -ne "Adding cpanel proxy"
		cp -f etc/cpnginx/cpanelproxy.conf /etc/cpnginx/
		echo -e "[ $GREEN DONE $RESET ]"
	fi
	echo -ne "Checking for vhost.conf "

	if [ -e "/etc/cpnginx/vhost.conf" ] ; then
	        echo -e "[ $GREEN YES $RESET ]"
	else
		echo -e "[ $RED No $RESET ]"
		cp -vf  etc/cpnginx/vhost.conf  /etc/cpnginx/
	fi
	if grep "monitornginxvhost"  /var/spool/cron/root ; then
		grep -v 'monitornginxvhost' /var/spool/cron/root >  /tmp/x.txt
        	echo "*/1 * * * * /usr/local/cpanel/scripts/monitornginxvhost > /dev/null 2>&1 " >> /tmp/x.txt
		cat /tmp/x.txt  > /var/spool/cron/root
        	echo "Monitoring Cron job updated "
	fi

	
	/usr/local/cpanel/scripts/rebuildnginxvhost
 	echo -ne "Upgrade Completed .."
	echo -e "[ $GREEN OK $RESET ]"
	exit 0
fi

echo " "
echo -ne "Checking for Yum .."
if [ -e  "/etc/yum.conf" ]; then
	echo -e "[ $GREEN YES $RESET ]"
else
	echo -e "[ $RED No $RESET ]"
	exit
fi

echo -ne "Checking for SED .."
if [ -e  "/bin/sed" ]; then
	echo -e "[ $GREEN YES $RESET ]"
else
	echo -e "[ $RED No $RESET ]"
	exit
fi

echo -ne "Checking for GREP .."
if [ -e  "/bin/grep" ]; then
	echo -e "[ $GREEN YES $RESET ]"
else
	echo -e "[ $RED No $RESET ]"
	exit
fi

echo -ne "Checking for Mailx .."
if [ -e  "/bin/mail" ]; then
	echo -e "[ $GREEN YES $RESET ]"
else
	echo -e "[ $RED No $RESET ]"
	yum -y install mailx
fi


echo -ne "Checking for cPanel config ..."
if grep "apache_port"  /var/cpanel/cpanel.config  > /dev/null ; then
        echo -e "[ $GREEN YES $RESET ]"
else
	echo -e "[ $RED No $RESET ]"
	echo 'apache_port=0.0.0.0:8888'  >> /var/cpanel/cpanel.config
	echo 'apache_ssl_port=0.0.0.0:443' >> /var/cpanel/cpanel.config
fi

echo -ne "Checking for Ioncube Loader..."
if /usr/local/cpanel/3rdparty/bin/php -v | grep 'ionCube' > /dev/null ;then
        echo -e "[ $GREEN YES $RESET ]"
else
        /usr/local/cpanel/scripts/phpextensionmgr  --prefix=/var/cpanel/3rdparty/ install IonCubeLoader
        sed -i 's/extension="timezonedb.so"/;/g' /usr/local/cpanel/3rdparty/etc/php.ini
fi


echo -ne "Installing cPanel Nginx Plugin..."
	chown root.root cgi/* -R
	chmod 700 cgi/addon_cpnginx.cgi
	cp -arf cgi/* 	/usr/local/cpanel/whostmgr/docroot/cgi/

        if [ -e "/usr/local/cpanel/bin/register_appconfig" ]; then
                if [ ! -d "/var/cpanel/apps" ]; then
                        mkdir /var/cpanel/apps
                chmod 755 /var/cpanel/apps
                fi
                /usr/local/cpanel/bin/register_appconfig /usr/local/cpanel/whostmgr/docroot/cgi/cpnginx/cpnginx.conf
                /bin/rm -f /usr/local/cpanel/whostmgr/docroot/cgi/addon_cpnginx.cgi
        else
                chmod -v 700 /usr/local/cpanel/whostmgr/docroot/cgi/addon_cpnginx.cgi
		if [ -e "/usr/local/cpanel/3rdparty/bin/perl" ]; then
			sed -i 's/#\!\/usr\/bin\/perl/#\!\/usr\/local\/cpanel\/3rdparty\/bin\/perl/g' /usr/local/cpanel/whostmgr/docroot/cgi/addon_cpnginx.cgi
		fi
        fi


	cp -arf etc/* /etc/
	chmod 700 scripts/*
	chown root.root scripts/* -R
	cp -arf scripts/*  /scripts/
	echo -e "[ $GREEN done $RESET ]"	



# install update cron

echo -ne "Checking for autoupdate cron"
if [ -e "/etc/cron.weekly/updatecpnginx.sh" ] ; then

	echo -e "[ $GREEN YES $RESET ]"
else
	echo -e "[ $RED No $RESET ]"
	cp -v  updatecpnginx.sh  /etc/cron.weekly/
	chmod 700 /etc/cron.weekly/updatecpnginx.sh
fi


/usr/local/cpanel/scripts/installnginx --version=1.6.0
if [ -e "/usr/local/nginx/sbin/nginx" ] ; then
	echo " Nginix found "
else
	echo "Nginx installation failed"
	exit
fi
/bin/chgrp nobody /home*/*/public_html
/usr/local/cpanel/scripts/installmodrpaf
/usr/local/cpanel/scripts/rebuildnginxvhost
if grep "monitornginxvhost"  /var/spool/cron/root ; then
	echo "Monitoring Cron already installed"
else
	echo "*/1 * * * * /usr/local/cpanel/scripts/monitornginxvhost > /dev/null 2>&1 " >> /var/spool/cron/root
	echo "Cron job installed"
fi
echo -e "--------------------------------------------------------------------------------------"
echo -e "				Installation Completed"
echo -e "	Please See the full documentation from http://docs.cpnginx.com"
echo -e "	If you have CSF enabled in this server please add the following line to /etc/csf/csf.pignore"
echo -e  " 		exe:/usr/local/nginx/sbin/nginx"
echo -e "	Then restart csf and lfd "
echo -e "--------------------------------------------------------------------------------------"
